<template>
  <div class="app-container">
    <el-drawer
      v-bind="$attrs"
      v-if="onOpen"
      v-on="$listeners"
      @opened="onOpen"
      @close="onClose"
      style="padding-left: 20px"
    >
      <el-row
        :gutter="10"
        class="mb8"
        style="margin-left: 25px; margin-top: 10px; margin-right: 0px"
      >
        <el-col :span="1.5">
          <el-button
            type="primary"
            plain
            icon="el-icon-plus"
            size="mini"
            @click="handleAdd"
            v-hasPermi="['work:emergencyDrill:add']"
            >添加</el-button
          >
        </el-col>
        <right-toolbar
          :showSearch.sync="showSearch"
          @queryTable="getworkTrainList"
        ></right-toolbar>
      </el-row>

      <el-table
        v-loading="loading"
        :data="workTrainList"
        @selection-change="handleSelectionChange"
        style="margin-left: 25px"
      >
        <el-table-column label="演练主图" align="center" prop="mainImage" width="75">
          <template slot-scope="scope">
            <el-image
              ref="preview"
              style="width: 50px; height: 50px"
              :src="getImageUrl(scope.row.mainImage)"
              @click="onPreview(scope.row.mainImage)"
            ></el-image>
          </template>
        </el-table-column>
        <el-table-column
          label="演练类型"
          align="center"
          prop="trainNature"
          width="130"
          show-overflow-tooltip
          v-if="false"
        >
          <template slot-scope="scope">
            <dict-tag
              :options="dict.type.train_nature_yjyl"
              :value="scope.row.trainNature"
            />
          </template>
        </el-table-column>
        <el-table-column
          label="演练标题"
          align="center"
          prop="trainTitle"
          width="160"
          show-overflow-tooltip
        />
        <el-table-column
          label="参与人数"
          align="center"
          prop="trainParticipants"
          width="90"
        />
        <el-table-column label="演练时间" align="center" prop="beginDate" width="100">
          <template slot-scope="scope">
            <div>{{ parseTime(scope.row.beginDate, "{y}-{m}-{d} {h}:{i}") }}</div>
          </template>
        </el-table-column>
        <el-table-column
          label="演练内容"
          align="center"
          prop="trainContent"
          width="170"
          show-overflow-tooltip
        />
        <el-table-column
          label="协同部门"
          align="center"
          prop="trainDeptNames"
          width="220"
          show-overflow-tooltip
        >
          <template slot-scope="scope">
            <div
              class="div_tag"
              v-for="dept in getTrainDeptNames(scope.row.trainDeptNames)"
            >
              <el-tag>{{ dept }}</el-tag>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          label="操作"
          align="center"
          width="120"
          class-name="small-padding fixed-width"
        >
          <template slot-scope="scope">
            <el-button
              v-if="scope.row.trainFile"
              size="mini"
              type="text"
              icon="el-icon-paperclip"
              @click="handleDownload(scope.row)"
              v-hasPermi="['work:emergencyDrill:edit']"
              >下载文件</el-button
            >
            <el-button
              v-if="scope.row.vDel == '0'"
              size="mini"
              type="text"
              icon="el-icon-edit"
              @click="handleUpdate(scope.row)"
              v-hasPermi="['work:emergencyDrill:edit']"
              >修改</el-button
            >
            <el-button
              v-if="scope.row.vDel == '0'"
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDelete(scope.row)"
              v-hasPermi="['work:emergencyDrill:remove']"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <pagination
        v-show="total > 0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getworkTrainList"
      />
      <el-dialog
        :title="title"
        v-if="open"
        :visible.sync="open"
        width="680px"
        append-to-body
        :close-on-click-modal="false"
        :close-on-press-escape="false"
      >
        <el-form ref="form" :model="form" :rules="rules" label-width="120px">
          <el-form-item label="项目名称">
            <el-input
              placeholder="项目名称"
              v-model="form.projectName"
              :disabled="true"
            ></el-input>
          </el-form-item>
          <el-form-item label="演练主图" prop="mainImage">
            <image-upload v-model="form.mainImage" :limit="1" />
          </el-form-item>
          <el-form-item label="演练类型" prop="trainNature" v-if="false">
            <el-select
              v-model="form.trainNature"
              placeholder="请选择演练类型"
              style="width: 100%"
            >
              <el-option
                v-for="dict in dict.type.train_nature_yjyl"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              ></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="演练标题" prop="trainTitle">
            <el-input v-model="form.trainTitle" placeholder="请输入演练标题" />
          </el-form-item>
          <el-form-item label="参与人数" prop="trainParticipants">
            <el-input-number
              v-model="form.trainParticipants"
              placeholder="请输入工作参与者"
              controls-position="right"
              style="width: 100%; text-align: left"
              :min="1"
            />
          </el-form-item>
          <el-form-item label="演练日期" prop="beginDate">
            <el-date-picker
              style="width: 100%"
              v-model="form.beginDate"
              type="datetime"
              placeholder="选择日期时间"
              default-time="10:00:00"
              value-format="yyyy-MM-dd HH:mm:ss"
            >
            </el-date-picker>
          </el-form-item>
          <el-form-item label="演练内容" prop="trainContent">
            <el-input
              type="textarea"
              v-model="form.trainContent"
              placeholder="请输入演练内容"
            />
          </el-form-item>
          <el-form-item label="相关文件" prop="trainFile">
            <FileUpload @input="fileInput" :limit="9" v-model="files" />
          </el-form-item>
          <el-form-item label="协同部门" prop="remark">
            <el-select
              v-model="form.workTrainDeptList"
              multiple
              placeholder="请选择协同部门"
              style="width: 100%"
            >
              <el-option
                v-for="item in deptOptions"
                :key="item.deptId"
                :label="item.deptName"
                :value="item.deptId"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog>
    </el-drawer>
    <el-image-viewer
      v-if="showViewer"
      :on-close="closeViewer"
      :url-list="previewList"
      style="z-index: 2050"
    />
  </div>
</template>

<script>
import {
  listWorkTrain,
  getWorkTrain,
  delWorkTrain,
  addWorkTrain,
  updateWorkTrain,
  listProjectUnit,
} from "@/api/work/emergencyDrill";
import ElImageViewer from "element-ui/packages/image/src/image-viewer";

export default {
  components: {
    ElImageViewer,
  },
  props: {
    formData: {
      projectId: String,
      projectName: String,
    },
  },
  dicts: ["train_nature_yjyl"],
  data() {
    return {
      showViewer: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 总条数
      total: 0,
      // 应急演练表格数据
      workTrainList: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 是否显示弹出层
      open: false,
      // 弹出层标题
      title: "",
      deptOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        trainType: 1,
        projectId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        mainImage: [{ required: true, message: "请上传演练主图", trigger: "blur" }],
        trainNature: [{ required: false, message: "请选择演练类型", trigger: "blur" }],
        beginDate: [{ required: true, message: "请选择演练时间", trigger: "blur" }],
        trainTitle: [
          { required: true, message: "请输入演练标题", trigger: "blur" },
          { max: 20, message: "培训标题最多20个字符", trigger: "blur" },
        ],
        trainParticipants: [
          { required: true, message: "请输入参与人数", trigger: "blur" },
        ],
        trainContent: [
          { required: true, message: "请输入演练内容", trigger: "blur" },
          { max: 1000, message: "演练内容长度在最多1000个字符", trigger: "blur" },
        ],
        trainFile: [{ required: true, message: "请上传相关附件", trigger: "blur" }],
      },
      previewList: [],
      files: [],
    };
  },
  computed: {},
  watch: {
    formData: {
      handler(value) {
        this.formData = value;
      },
      immediate: true,
    },
  },
  created() {},
  mounted() {},
  beforeDestroy() {},
  methods: {
    getImageUrl(url) {
      return process.env.VUE_APP_BASE_API + url + ".min.jpg";
    },
    onPreview(url) {
      this.previewList = [];
      this.previewList.push(process.env.VUE_APP_BASE_API + url);
      this.showViewer = true;
    },
    closeViewer() {
      this.showViewer = false;
    },
    getTrainDeptNames(vals) {
      if (vals != null) {
        return vals.split(",");
      } else {
        return [];
      }
    },
    onOpen() {
      this.getworkTrainList();
    },
    onClose() {},
    /** 查询应急演练列表 */
    getworkTrainList() {
      if (this.formData.projectId) {
        this.loading = true;
        this.queryParams.projectId = this.formData.projectId;
        listWorkTrain(this.queryParams).then((response) => {
          this.workTrainList = response.rows;
          this.total = response.total;
          this.loading = false;
        });
      }
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        projectId: null,
        projectName: null,
        mainImage: null,
        trainType: null,
        trainNature: null,
        trainTitle: null,
        trainParticipants: null,
        beginDate: null,
        endDate: null,
        isDel: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        remark: null,
      };
      this.files = [];
      this.deptOptions = [];
      this.resetForm("form");
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.form.projectId = this.formData.projectId;
      this.form.projectName = this.formData.projectName;
      this.open = true;
      this.title = "添加应急演练";
      this.getDeptList();
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 获取协同部门列表
    getDeptList(id) {
      this.loading = true;
      let param = {
        projectId: this.form.projectId,
      };
      //获取项目部门列表的接口
      listProjectUnit(param).then((response) => {
        this.loading = false;
        this.deptOptions = response.data;
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          // 重新组装部门数据
          let depts = [];
          this.form.workTrainDeptList.forEach((item) => {
            depts.push({ deptId: item });
          });
          this.form.workTrainDeptList = depts;
          if (this.form.id != null) {
            updateWorkTrain(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getworkTrainList();
            });
          } else {
            this.form.trainType = 1;
            this.form.isDel = 0;
            addWorkTrain(this.form).then((response) => {
              this.$modal.msgSuccess("添加成功");
              this.open = false;
              this.getworkTrainList();
            });
          }
        }
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.title = "修改应急演练";
      const id = row.id || this.ids;
      let param = {
        projectId: this.formData.projectId,
      };
      //获取项目部门列表的接口
      listProjectUnit(param).then((response) => {
        this.deptOptions = response.data;
        this.open = true;
      });
      getWorkTrain(id).then((response) => {
        this.form = response.data;
        let depts = [];
        this.form.workTrainDeptList.forEach((item) => {
          depts.push(item.deptId);
        });
        this.form.workTrainDeptList = depts;
        if (that.form.trainFile) {
          that.files = that.form.trainFile.split(",");
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除应急演练编号为"' + ids + '"的数据项？')
        .then(function () {
          return delSurProjectUserInfo(ids);
        })
        .then(() => {
          this.getworkTrainList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    //文件输入
    fileInput(files) {
      let trainFile = "";
      if (files.length > 0) {
        files.forEach((item) => {
          trainFile += "," + item.url;
        });
        trainFile = trainFile.substring(1);
      }
      this.form.trainFile = trainFile;
    },
    handleDownload(row) {
      this.files = row.trainFile.split(",");
      this.files.forEach((item) => {
        this.$download.resource(item);
      });
    },
  },
};
</script>
<style lang="scss" scoped>
@import "@/styles/mixin.scss";

::v-deep .el-drawer__header {
  display: none;
}
@include action-bar;

.json-editor {
  height: calc(100vh - 33px);
}
.div_tag {
  margin-bottom: 5px;
}
</style>
